diff --git a/gcc/ipa-fnsummary.c b/gcc/ipa-fnsummary.c
index 0e74fc3..3b68078 100644
--- a/gcc/ipa-fnsummary.c
+++ b/gcc/ipa-fnsummary.c
@@ -149,7 +149,7 @@ ipa_dump_hints (FILE *f, ipa_hints hints)
 
 /* Record SIZE and TIME to SUMMARY.
    The accounted code will be executed when EXEC_PRED is true.
-   When NONCONST_PRED is false the code will evaulate to constant and
+   When NONCONST_PRED is false the code will evaluate to constant and
    will get optimized out in specialized clones of the function.   */
 
 void
@@ -170,7 +170,7 @@ ipa_fn_summary::account_size_time (int size, sreal time,
   if (nonconst_pred == false)
     return;
 
-  /* We need to create initial empty unconitional clause, but otherwie
+  /* We need to create initial empty unconditional clause, but otherwise
      we don't need to account empty times and sizes.  */
   if (!size && time == 0 && size_time_table)
     return;
@@ -301,9 +301,9 @@ set_hint_predicate (predicate **p, predicate new_predicate)
 }
 
 
-/* Compute what conditions may or may not hold given invormation about
+/* Compute what conditions may or may not hold given information about
    parameters.  RET_CLAUSE returns truths that may hold in a specialized copy,
-   whie RET_NONSPEC_CLAUSE returns truths that may hold in an nonspecialized
+   while RET_NONSPEC_CLAUSE returns truths that may hold in an nonspecialized
    copy when called in a given context.  It is a bitmask of conditions. Bit
    0 means that condition is known to be false, while bit 1 means that condition
    may or may not be true.  These differs - for example NOT_INLINED condition
@@ -311,7 +311,7 @@ set_hint_predicate (predicate **p, predicate new_predicate)
    the fact that parameter is indeed a constant.
 
    KNOWN_VALS is partial mapping of parameters of NODE to constant values.
-   KNOWN_AGGS is a vector of aggreggate jump functions for each parameter.
+   KNOWN_AGGS is a vector of aggregate jump functions for each parameter.
    Return clause of possible truths. When INLINE_P is true, assume that we are
    inlining.
 
@@ -534,7 +534,7 @@ ipa_fn_summary_alloc (void)
 }
 
 /* We are called multiple time for given function; clear
-   data from previous run so they are not cumulated.  */
+   data from previous run so they are not accumulated.  */
 
 void
 ipa_call_summary::reset ()
@@ -547,7 +547,7 @@ ipa_call_summary::reset ()
 }
 
 /* We are called multiple time for given function; clear
-   data from previous run so they are not cumulated.  */
+   data from previous run so they are not accumulated.  */
 
 void
 ipa_fn_summary::reset (struct cgraph_node *node)
@@ -673,7 +673,7 @@ ipa_fn_summary_t::duplicate (cgraph_node *src,
       info->account_size_time (0, 0, true_pred, true_pred);
 
       /* Remap size_time vectors.
-         Simplify the predicate by prunning out alternatives that are known
+         Simplify the predicate by pruning out alternatives that are known
          to be false.
          TODO: as on optimization, we can also eliminate conditions known
          to be true.  */
@@ -711,7 +711,7 @@ ipa_fn_summary_t::duplicate (cgraph_node *src,
 	  edge_set_predicate (edge, &new_predicate);
 	}
 
-      /* Remap indirect edge predicates with the same simplificaiton as above. 
+      /* Remap indirect edge predicates with the same simplification as above.
          Also copy constantness arrays.   */
       for (edge = dst->indirect_calls; edge; edge = next)
 	{
@@ -738,7 +738,7 @@ ipa_fn_summary_t::duplicate (cgraph_node *src,
       /* If inliner or someone after inliner will ever start producing
          non-trivial clones, we will get trouble with lack of information
          about updating self sizes, because size vectors already contains
-         sizes of the calees.  */
+         sizes of the callees.  */
       gcc_assert (!inlined_to_p || !optimized_out_size);
     }
   else
@@ -1150,12 +1150,12 @@ eliminated_by_inlining_prob (gimple *stmt)
 	    lhs_free = true;
 
 	  /* Writes to parameters, parameters passed by value and return value
-	     (either dirrectly or passed via invisible reference) are free.  
+	     (either directly or passed via invisible reference) are free.
 
 	     TODO: We ought to handle testcase like
 	     struct a {int a,b;};
 	     struct a
-	     retrurnsturct (void)
+	     returnstruct (void)
 	     {
 	     struct a a ={1,2};
 	     return a;
@@ -1163,7 +1163,7 @@ eliminated_by_inlining_prob (gimple *stmt)
 
 	     This translate into:
 
-	     retrurnsturct ()
+	     returnstruct ()
 	     {
 	     int a$b;
 	     int a$a;
@@ -1239,7 +1239,7 @@ set_cond_stmt_execution_predicate (struct ipa_func_body_info *fbi,
 	  enum tree_code this_code = (e->flags & EDGE_TRUE_VALUE
 				      ? code : inverted_code);
 	  /* invert_tree_comparison will return ERROR_MARK on FP
-	     comparsions that are not EQ/NE instead of returning proper
+	     comparisons that are not EQ/NE instead of returning proper
 	     unordered one.  Be sure it is not confused with NON_CONSTANT.  */
 	  if (this_code != ERROR_MARK)
 	    {
@@ -1263,7 +1263,7 @@ set_cond_stmt_execution_predicate (struct ipa_func_body_info *fbi,
      Here we can predicate nonconstant_code.  We can't
      really handle constant_code since we have no predicate
      for this and also the constant code is not known to be
-     optimized away when inliner doen't see operand is constant.
+     optimized away when inliner doesn't see operand is constant.
      Other optimizers might think otherwise.  */
   if (gimple_cond_code (last) != NE_EXPR
       || !integer_zerop (gimple_cond_rhs (last)))
@@ -1510,7 +1510,7 @@ will_be_nonconstant_predicate (struct ipa_func_body_info *fbi,
   HOST_WIDE_INT size;
   struct agg_position_info aggpos;
 
-  /* What statments might be optimized away
+  /* What statements might be optimized away
      when their arguments are constant.  */
   if (gimple_code (stmt) != GIMPLE_ASSIGN
       && gimple_code (stmt) != GIMPLE_COND
@@ -1593,7 +1593,7 @@ struct record_modified_bb_info
   gimple *stmt;
 };
 
-/* Value is initialized in INIT_BB and used in USE_BB.  We want to copute
+/* Value is initialized in INIT_BB and used in USE_BB.  We want to compute
    probability how often it changes between USE_BB.
    INIT_BB->frequency/USE_BB->frequency is an estimate, but if INIT_BB
    is in different loop nest, we can do better.
@@ -1703,7 +1703,7 @@ param_change_prob (gimple *stmt, int i)
 	}
 
       /* Assume that every memory is initialized at entry.
-         TODO: Can we easilly determine if value is always defined
+         TODO: Can we easily determine if value is always defined
          and thus we may skip entry block?  */
       if (ENTRY_BLOCK_PTR_FOR_FN (cfun)->frequency)
 	max = ENTRY_BLOCK_PTR_FOR_FN (cfun)->frequency;
@@ -1911,7 +1911,7 @@ find_foldable_builtin_expect (basic_block bb)
    presence of EH and will be optimized out by optimize_clobbers later in the
    game. 
 
-   NEED_EH is used to recurse in case the clobber has non-EH predecestors
+   NEED_EH is used to recurse in case the clobber has non-EH predecessors
    that can be clobber only, too.. When it is false, the RESX is not necessary
    on the end of basic block.  */
 
@@ -1945,7 +1945,7 @@ clobber_only_eh_bb_p (basic_block bb, bool need_eh = true)
       return false;
     }
 
-  /* See if all predecestors are either throws or clobber only BBs.  */
+  /* See if all predecessors are either throws or clobber only BBs.  */
   FOR_EACH_EDGE (e, ei, bb->preds)
     if (!(e->flags & EDGE_EH)
 	&& !clobber_only_eh_bb_p (e->src, false))
@@ -2186,7 +2186,7 @@ analyze_function_body (struct cgraph_node *node, bool early)
 	      edge_set_predicate (edge, &bb_predicate);
 	    }
 
-	  /* TODO: When conditional jump or swithc is known to be constant, but
+	  /* TODO: When conditional jump or switch is known to be constant, but
 	     we did not translate it into the predicates, we really can account
 	     just maximum of the possible paths.  */
 	  if (fbi.info)
@@ -2285,7 +2285,7 @@ analyze_function_body (struct cgraph_node *node, bool early)
 		will_be_nonconstant = bb_predicate & will_be_nonconstant;
 	      if (will_be_nonconstant != true
 		  && will_be_nonconstant != false)
-		/* This is slightly inprecise.  We may want to represent each
+		/* This is slightly imprecise.  We may want to represent each
 		   loop with independent predicate.  */
 		loop_iterations &= will_be_nonconstant;
 	    }
@@ -2330,7 +2330,7 @@ analyze_function_body (struct cgraph_node *node, bool early)
 		    will_be_nonconstant = bb_predicate & will_be_nonconstant;
 		  if (will_be_nonconstant != true
 		      && will_be_nonconstant != false)
-		    /* This is slightly inprecise.  We may want to represent
+		    /* This is slightly imprecise.  We may want to represent
 		       each loop with independent predicate.  */
 		    loop_stride = loop_stride & will_be_nonconstant;
 		}
@@ -2646,7 +2646,7 @@ estimate_calls_size_and_time (struct cgraph_node *node, int *size,
    POSSIBLE_TRUTHS clause, and KNOWN_VALS, KNOWN_AGGS and KNOWN_CONTEXTS
    information about NODE's arguments.  If non-NULL use also probability
    information present in INLINE_PARAM_SUMMARY vector.
-   Additionally detemine hints determined by the context.  Finally compute
+   Additionally determine hints determined by the context.  Finally compute
    minimal size needed for the call that is independent on the call context and
    can be used for fast estimates.  Return the values in RET_SIZE,
    RET_MIN_SIZE, RET_TIME and RET_HINTS.  */
@@ -2747,7 +2747,7 @@ estimate_node_size_and_time (struct cgraph_node *node,
   gcc_checking_assert ((nonspecialized_time - time) >= -1);
 
   /* Roundoff issues may make specialized time bigger than nonspecialized
-     time.  We do not really want that to happen because some heurstics
+     time.  We do not really want that to happen because some heuristics
      may get confused by seeing negative speedups.  */
   if (time > nonspecialized_time)
     time = nonspecialized_time;
@@ -2842,8 +2842,8 @@ inline_update_callee_summaries (struct cgraph_node *node, int depth)
 }
 
 /* Update change_prob of EDGE after INLINED_EDGE has been inlined.
-   When functoin A is inlined in B and A calls C with parameter that
-   changes with probability PROB1 and C is known to be passthroug
+   When function A is inlined in B and A calls C with parameter that
+   changes with probability PROB1 and C is known to be passthrough
    of argument if B that change with probability PROB2, the probability
    of change is now PROB1*PROB2.  */
 
@@ -3541,7 +3541,7 @@ const pass_data pass_data_ipa_free_fn_summary =
   0, /* properties_destroyed */
   0, /* todo_flags_start */
   /* Early optimizations may make function unreachable.  We can not
-     remove unreachable functions as part of the ealry opts pass because
+     remove unreachable functions as part of the early opts pass because
      TODOs are run before subpasses.  Do it here.  */
   ( TODO_remove_functions | TODO_dump_symtab ), /* todo_flags_finish */
 };
diff --git a/gcc/ipa-fnsummary.h b/gcc/ipa-fnsummary.h
index f50d680..6e222c6 100644
--- a/gcc/ipa-fnsummary.h
+++ b/gcc/ipa-fnsummary.h
@@ -25,14 +25,14 @@ along with GCC; see the file COPYING3.  If not see
 #include "ipa-predicate.h"
 
 
-/* Hints are reasons why IPA heuristics should preffer specializing given
-   function.  They are represtented as bitmap of the following values.  */
+/* Hints are reasons why IPA heuristics should prefer specializing given
+   function.  They are represented as bitmap of the following values.  */
 enum ipa_hints_vals {
   /* When specialization turns indirect call into a direct call,
      it is good idea to do so.  */
   INLINE_HINT_indirect_call = 1,
   /* Inlining may make loop iterations or loop stride known.  It is good idea
-     to do so because it enables loop optimizatoins.  */
+     to do so because it enables loop optimizations.  */
   INLINE_HINT_loop_iterations = 2,
   INLINE_HINT_loop_stride = 4,
   /* Inlining within same strongly connected component of callgraph is often
diff --git a/gcc/ipa-icf-gimple.c b/gcc/ipa-icf-gimple.c
index 08dd980..8323921 100644
--- a/gcc/ipa-icf-gimple.c
+++ b/gcc/ipa-icf-gimple.c
@@ -232,7 +232,7 @@ func_checker::compatible_types_p (tree t1, tree t2)
   if (!types_compatible_p (t1, t2))
     return return_false_with_msg ("types are not compatible");
 
-  /* We do a lot of unnecesary matching of types that are not being
+  /* We do a lot of unnecessary matching of types that are not being
      accessed and thus do not need to be compatible.  In longer term we should
      remove these checks on all types which are not accessed as memory
      locations.
@@ -449,7 +449,7 @@ func_checker::compare_operand (tree t1, tree t2)
 
 	In this case the alias set of the function being replaced must
 	be subset of the alias set of the other function.  At the moment
-	we seek for equivalency classes, so simply require inclussion in
+	we seek for equivalency classes, so simply require inclusion in
 	both directions.  */
 
 	if (!func_checker::compatible_types_p (TREE_TYPE (x1), TREE_TYPE (x2)))
@@ -989,7 +989,7 @@ func_checker::compare_gimple_asm (const gasm *g1, const gasm *g2)
   if (gimple_asm_noutputs (g1) != gimple_asm_noutputs (g2))
     return false;
 
-  /* We do not suppport goto ASM statement comparison.  */
+  /* We do not support goto ASM statement comparison.  */
   if (gimple_asm_nlabels (g1) || gimple_asm_nlabels (g2))
     return false;
 
diff --git a/gcc/ipa-icf-gimple.h b/gcc/ipa-icf-gimple.h
index da904b5..95a67bc 100644
--- a/gcc/ipa-icf-gimple.h
+++ b/gcc/ipa-icf-gimple.h
@@ -19,13 +19,13 @@ You should have received a copy of the GNU General Public License
 along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
-/* Gimple identical code folding (class func_checker) is an infastructure
+/* Gimple identical code folding (class func_checker) is an infrastructure
    capable of comparing two given functions. The class compares every
    gimple statement and uses many dictionaries to map source and target
    SSA_NAMEs, declarations and other components.
 
-   To use the infrastructure, create an instanse of func_checker and call
-   a comparsion function based on type of gimple statement.  */
+   To use the infrastructure, create an instance of func_checker and call
+   a comparison function based on type of gimple statement.  */
 
 /* Prints string STRING to a FILE with a given number of SPACE_COUNT.  */
 #define FPUTS_SPACES(file, space_count, string) \
@@ -227,7 +227,7 @@ public:
   bool compare_variable_decl (tree t1, tree t2);
 
   /* Return true if types are compatible for polymorphic call analysis.
-     COMPARE_PTR indicates if polymorphic type comparsion should be
+     COMPARE_PTR indicates if polymorphic type comparison should be
      done for pointers, too.  */
   static bool compatible_polymorphic_types_p (tree t1, tree t2,
 					      bool compare_ptr);
diff --git a/gcc/ipa-icf.c b/gcc/ipa-icf.c
index 0b0c1fd..cc9f5f7 100644
--- a/gcc/ipa-icf.c
+++ b/gcc/ipa-icf.c
@@ -355,7 +355,7 @@ sem_item::compare_attributes (const_tree a1, const_tree a2)
 
 /* Compare properties of symbols N1 and N2 that does not affect semantics of
    symbol itself but affects semantics of its references from USED_BY (which
-   may be NULL if it is unknown).  If comparsion is false, symbols
+   may be NULL if it is unknown).  If comparison is false, symbols
    can still be merged but any symbols referring them can't.
 
    If ADDRESS is true, do extra checking needed for IPA_REF_ADDR.
@@ -1160,7 +1160,7 @@ sem_function::merge (sem_item *alias_item)
         }
       /* Do not turn function in one comdat group into wrapper to another
 	 comdat group. Other compiler producing the body of the
-	 another comdat group may make opossite decision and with unfortunate
+	 another comdat group may make opposite decision and with unfortunate
 	 linker choices this may close a loop.  */
       else if (DECL_COMDAT_GROUP (original->decl)
 	       && DECL_COMDAT_GROUP (alias->decl)
@@ -2201,7 +2201,7 @@ sem_variable::merge (sem_item *alias_item)
       return false;
     }
 
-  /* We can not merge if address comparsion metters.  */
+  /* We can not merge if address comparison matters.  */
   if (alias_address_matters && flag_merge_constants < 2)
     {
       if (dump_file)
@@ -3315,7 +3315,7 @@ sem_item_optimizer::process_cong_reduction (void)
 	     "new classes.\n", new_classes);
 }
 
-/* Debug function prints all informations about congruence classes.  */
+/* Debug function prints all information about congruence classes.  */
 
 void
 sem_item_optimizer::dump_cong_classes (void)
@@ -3621,7 +3621,7 @@ ipa_icf_read_summary (void)
   optimizer->register_hooks ();
 }
 
-/* Semantic equality exection function.  */
+/* Semantic equality execution function.  */
 
 static unsigned int
 ipa_icf_driver (void)
diff --git a/gcc/ipa-icf.h b/gcc/ipa-icf.h
index c57224c..69aa3e3 100644
--- a/gcc/ipa-icf.h
+++ b/gcc/ipa-icf.h
@@ -24,7 +24,7 @@ class sem_item;
 
 /* Congruence class encompasses a collection of either functions or
    read-only variables. These items are considered to be equivalent
-   if not proved the oposite.  */
+   if not proved the opposite.  */
 class congruence_class
 {
 public:
@@ -172,7 +172,7 @@ public:
   virtual bool equals_wpa (sem_item *item,
 			   hash_map <symtab_node *, sem_item *> &ignored_nodes) = 0;
 
-  /* Returns true if the item equals to ITEM given as arguemnt.  */
+  /* Returns true if the item equals to ITEM given as argument.  */
   virtual bool equals (sem_item *item,
 		       hash_map <symtab_node *, sem_item *> &ignored_nodes) = 0;
 
@@ -329,7 +329,7 @@ public:
   static sem_function *parse (cgraph_node *node, bitmap_obstack *stack);
 
   /* Perform additional checks needed to match types of used function
-     paramters.  */
+     parameters.  */
   bool compatible_parm_types_p (tree, tree);
 
   /* Exception handling region tree.  */
@@ -548,7 +548,7 @@ private:
      is split.  */
   unsigned subdivide_classes_by_sensitive_refs();
 
-  /* Debug function prints all informations about congruence classes.  */
+  /* Debug function prints all information about congruence classes.  */
   void dump_cong_classes (void);
 
   /* Build references according to call graph.  */
@@ -587,7 +587,7 @@ private:
   static bool release_split_map (congruence_class * const &cls, bitmap const &b,
 				 traverse_split_pair *pair);
 
-  /* Process split operation for a cognruence class CLS,
+  /* Process split operation for a congruence class CLS,
      where bitmap B splits congruence class members. DATA is used
      as argument of split pair.  */
   static bool traverse_congruence_split (congruence_class * const &cls,
diff --git a/gcc/ipa-inline-transform.c b/gcc/ipa-inline-transform.c
index 01a6833..b4c5cab 100644
--- a/gcc/ipa-inline-transform.c
+++ b/gcc/ipa-inline-transform.c
@@ -179,7 +179,7 @@ clone_inlined_nodes (struct cgraph_edge *e, bool duplicate,
     {
       /* We may eliminate the need for out-of-line copy to be output.
 	 In that case just go ahead and re-use it.  This is not just an
-	 memory optimization.  Making offline copy of fuction disappear
+	 memory optimization.  Making offline copy of function disappear
 	 from the program will improve future decisions on inlining.  */
       if (!e->callee->callers->next_caller
 	  /* Recursive inlining never wants the master clone to
diff --git a/gcc/ipa-inline.c b/gcc/ipa-inline.c
index 0ebe147..6bb3c2a 100644
--- a/gcc/ipa-inline.c
+++ b/gcc/ipa-inline.c
@@ -395,7 +395,7 @@ can_inline_edge_p (struct cgraph_edge *e, bool report,
       ipa_fn_summary *callee_info = ipa_fn_summaries->get (callee);
 
      /* Until GCC 4.9 we did not check the semantics alterning flags
-	bellow and inline across optimization boundry.
+	below and inline across optimization boundary.
 	Enabling checks bellow breaks several packages by refusing
 	to inline library always_inline functions. See PR65873.
 	Disable the check for early inlining for now until better solution
@@ -431,7 +431,7 @@ can_inline_edge_p (struct cgraph_edge *e, bool report,
 		  && DECL_FUNCTION_PERSONALITY (callee->decl))
 	      || (check_maybe_up (flag_exceptions)
 		  && DECL_FUNCTION_PERSONALITY (callee->decl))
-	      /* When devirtualization is diabled for callee, it is not safe
+	      /* When devirtualization is disabled for callee, it is not safe
 		 to inline it as we possibly mangled the type info.
 		 Allow early inlining of always inlines.  */
 	      || (!early && check_maybe_down (flag_devirtualize)))
@@ -1084,7 +1084,7 @@ edge_badness (struct cgraph_edge *edge, bool dump)
 	     if (need_more_work)
 	       noninline_callee ();
 	   }
-	 Withhout panilizing this case, we usually inline noninline_callee
+	 Withhout penalizing this case, we usually inline noninline_callee
 	 into the inline_caller because overall_growth is small preventing
 	 further inlining of inline_caller.
 
@@ -1131,7 +1131,7 @@ edge_badness (struct cgraph_edge *edge, bool dump)
 	}
       if (overall_growth > 0)
         {
-	  /* Strongly preffer functions with few callers that can be inlined
+	  /* Strongly prefer functions with few callers that can be inlined
 	     fully.  The square root here leads to smaller binaries at average.
 	     Watch however for extreme cases and return to linear function
 	     when growth is large.  */
@@ -1217,7 +1217,7 @@ update_edge_key (edge_heap_t *heap, struct cgraph_edge *edge)
       gcc_checking_assert (n->get_data () == edge);
 
       /* fibonacci_heap::replace_key does busy updating of the
-	 heap that is unnecesarily expensive.
+	 heap that is unnecessarily expensive.
 	 We do lazy increases: after extracting minimum if the key
 	 turns out to be out of date, it is re-inserted into heap
 	 with correct value.  */
@@ -1251,7 +1251,7 @@ update_edge_key (edge_heap_t *heap, struct cgraph_edge *edge)
 
 
 /* NODE was inlined.
-   All caller edges needs to be resetted because
+   All caller edges needs to be reset because
    size estimates change. Similarly callees needs reset
    because better context may be known.  */
 
@@ -1366,7 +1366,7 @@ update_callee_keys (edge_heap_t *heap, struct cgraph_node *node,
 	enum availability avail;
 	struct cgraph_node *callee;
 	/* We do not reset callee growth cache here.  Since we added a new call,
-	   growth chould have just increased and consequentely badness metric
+	   growth could have just increased and consequently badness metric
            don't need updating.  */
 	if (e->inline_failed
 	    && (callee = e->callee->ultimate_alias_target (&avail, e->caller))
@@ -1877,7 +1877,7 @@ inline_small_functions (void)
       edge_growth_cache[edge->uid].hints = old_hints_est + 1;
 
       /* When updating the edge costs, we only decrease badness in the keys.
-	 Increases of badness are handled lazilly; when we see key with out
+	 Increases of badness are handled lazily; when we see key with out
 	 of date value on it, we re-insert it now.  */
       current_badness = edge_badness (edge, false);
       /* Disable checking for profile because roundoff errors may cause slight
@@ -2442,7 +2442,7 @@ ipa_inline (void)
      into callee often leads to better optimization of callee due to
      increased context for optimization.
      For example if main() function calls a function that outputs help
-     and then function that does the main optmization, we should inline
+     and then function that does the main optimization, we should inline
      the second with priority even if both calls are cold by themselves.
 
      We probably want to implement new predicate replacing our use of
@@ -2631,7 +2631,7 @@ early_inliner (function *fun)
     node->verify ();
   node->remove_all_references ();
 
-  /* Rebuild this reference because it dosn't depend on
+  /* Rebuild this reference because it doesn't depend on
      function's body and it's required to pass cgraph_node
      verification.  */
   if (node->instrumented_version
diff --git a/gcc/ipa-polymorphic-call.c b/gcc/ipa-polymorphic-call.c
index abbcfbf..dfc18c7 100644
--- a/gcc/ipa-polymorphic-call.c
+++ b/gcc/ipa-polymorphic-call.c
@@ -100,7 +100,7 @@ possible_placement_new (tree type, tree expected_type,
    to represent it.
 
    If OTR_TYPE is NULL, just find outermost polymorphic type with
-   virtual table present at possition OFFSET.
+   virtual table present at position OFFSET.
 
    For example when THIS represents type
    class A
@@ -148,7 +148,7 @@ ipa_polymorphic_call_context::restrict_to_inner_class (tree otr_type,
     Because the instance type may contain field whose type is of OUTER_TYPE,
     we can not derive any effective information about it.
 
-    TODO: In the case we know all derrived types, we can definitely do better
+    TODO: In the case we know all derived types, we can definitely do better
     here.  */
   else if (TYPE_SIZE (outer_type)
 	   && tree_fits_shwi_p (TYPE_SIZE (outer_type))
@@ -241,7 +241,7 @@ ipa_polymorphic_call_context::restrict_to_inner_class (tree otr_type,
 	      if (cur_offset != 0)
 		goto no_useful_type_info;
 	      /* If we determined type precisely or we have no clue on
- 		 speuclation, we are done.  */
+ 		 speculation, we are done.  */
 	      if (!maybe_derived_type || !speculative_outer_type
 		  || !speculation_consistent_p (speculative_outer_type,
 					        speculative_offset,
@@ -395,7 +395,7 @@ no_useful_type_info:
 	      else
 		return true;
 	    }
-	  /* We found no way to embedd EXPECTED_TYPE in TYPE.
+	  /* We found no way to embed EXPECTED_TYPE in TYPE.
 	     We still permit two special cases - placement new and
 	     the case of variadic types containing themselves.  */
 	  if (!speculative
@@ -552,7 +552,7 @@ decl_maybe_in_construction_p (tree base, tree outer_type,
     return true;
 
   /* Pure functions can not do any changes on the dynamic type;
-     that require writting to memory.  */
+     that require writing to memory.  */
   if ((!base || !auto_var_in_fn_p (base, function))
       && flags_from_decl_or_type (function) & (ECF_PURE | ECF_CONST))
     return false;
@@ -917,7 +917,7 @@ ipa_polymorphic_call_context::ipa_polymorphic_call_context (tree fndecl,
 	      && max_size == size)
 	    {
 	      /* We found dereference of a pointer.  Type of the pointer
-		 and MEM_REF is meaningless, but we can look futher.  */
+		 and MEM_REF is meaningless, but we can look further.  */
 	      if (TREE_CODE (base) == MEM_REF)
 		{
 		  base_pointer = TREE_OPERAND (base, 0);
@@ -1078,7 +1078,7 @@ ipa_polymorphic_call_context::ipa_polymorphic_call_context (tree fndecl,
 			      offset,
 			      true, NULL /* Do not change type here */);
   /* TODO: There are multiple ways to derive a type.  For instance
-     if BASE_POINTER is passed to an constructor call prior our refernece.
+     if BASE_POINTER is passed to an constructor call prior our reference.
      We do not make this type of flow sensitive analysis yet.  */
   if (instance)
     *instance = base_pointer;
@@ -1282,7 +1282,7 @@ extr_type_from_vtbl_ptr_store (gimple *stmt, struct type_change_info *tci,
     {
       if (dump_file)
 	fprintf (dump_file, "    Construction vtable used\n");
-      /* FIXME: We should suport construction contexts.  */
+      /* FIXME: We should support construction contexts.  */
       return NULL;
     }
  
@@ -1533,7 +1533,7 @@ ipa_polymorphic_call_context::get_dynamic_type (tree instance,
     otr_type = TYPE_MAIN_VARIANT (otr_type);
 
   /* Walk into inner type. This may clear maybe_derived_type and save us
-     from useless work.  It also makes later comparsions with static type
+     from useless work.  It also makes later comparisons with static type
      easier.  */
   if (outer_type && otr_type)
     {
@@ -1549,7 +1549,7 @@ ipa_polymorphic_call_context::get_dynamic_type (tree instance,
   if (TREE_CODE (instance) == MEM_REF)
     return false;
 
-  /* We need to obtain refernce to virtual table pointer.  It is better
+  /* We need to obtain reference to virtual table pointer.  It is better
      to look it up in the code rather than build our own.  This require bit
      of pattern matching, but we end up verifying that what we found is
      correct. 
@@ -1723,7 +1723,7 @@ ipa_polymorphic_call_context::get_dynamic_type (tree instance,
 
      Therefore if the static outer type was found (outer_type)
      we can safely ignore tci.speculative that is set on calls and give up
-     only if there was dyanmic type store that may affect given variable
+     only if there was dynamic type store that may affect given variable
      (seen_unanalyzed_store)  */
 
   if (!tci.type_maybe_changed
@@ -1850,7 +1850,7 @@ ipa_polymorphic_call_context::combine_speculation_with
     return false;
 
   /* restrict_to_inner_class may eliminate wrong speculation making our job
-     easeier.  */
+     easier.  */
   if (otr_type)
     restrict_to_inner_class (otr_type);
 
@@ -1898,7 +1898,7 @@ ipa_polymorphic_call_context::combine_speculation_with
     }
   /* Choose type that contains the other.  This one either contains the outer
      as a field (thus giving exactly one target) or is deeper in the type
-     hiearchy.  */
+     hierarchy.  */
   else if (speculative_outer_type
 	   && speculative_maybe_derived_type
 	   && (new_offset > speculative_offset
@@ -1950,7 +1950,7 @@ ipa_polymorphic_call_context::meet_speculation_with
     }
 
   /* restrict_to_inner_class may eliminate wrong speculation making our job
-     easeier.  */
+     easier.  */
   if (otr_type)
     restrict_to_inner_class (otr_type);
 
@@ -2030,8 +2030,8 @@ ipa_polymorphic_call_context::meet_speculation_with
     }
 }
 
-/* Assume that both THIS and a given context is valid and strenghten THIS
-   if possible.  Return true if any strenghtening was made.
+/* Assume that both THIS and a given context is valid and strengthen THIS
+   if possible.  Return true if any strengthening was made.
    If actual type the context is being used in is known, OTR_TYPE should be
    set accordingly. This improves quality of combined result.  */
 
@@ -2196,7 +2196,7 @@ ipa_polymorphic_call_context::combine_with (ipa_polymorphic_call_context ctx,
 	      goto invalidate;
 	    }
 	}
-      /* Pick variant deeper in the hiearchy.  */
+      /* Pick variant deeper in the hierarchy.  */
       else
 	{
 	  outer_type = ctx.outer_type;
@@ -2522,7 +2522,7 @@ ipa_polymorphic_call_context::meet_with (ipa_polymorphic_call_context ctx,
       if (!dynamic && ctx.dynamic)
 	dynamic = true;
     }
-  /* TODO handle merging using hiearchy. */
+  /* TODO handle merging using hierarchy. */
   else
     {
       if (dump_file && (dump_flags & TDF_DETAILS))
diff --git a/gcc/ipa-predicate.c b/gcc/ipa-predicate.c
index f10e234..60b4092 100644
--- a/gcc/ipa-predicate.c
+++ b/gcc/ipa-predicate.c
@@ -338,8 +338,8 @@ dump_clause (FILE *f, conditions conds, clause_t clause)
 }
 
 
-/* Dump THIS to F. CONDS a vector of conditions used when evauating
-   predicats. When NL is true new line is output at the end of dump.  */
+/* Dump THIS to F. CONDS a vector of conditions used when evaluating
+   predicates. When NL is true new line is output at the end of dump.  */
 
 void
 predicate::dump (FILE *f, conditions conds, bool nl) const
diff --git a/gcc/ipa-predicate.h b/gcc/ipa-predicate.h
index 6d48819..7e5bd81 100644
--- a/gcc/ipa-predicate.h
+++ b/gcc/ipa-predicate.h
@@ -86,7 +86,7 @@ public:
       first_dynamic_condition = 2
     };
 
-  /* Maximal number of conditions predicate can reffer to.  This is limited
+  /* Maximal number of conditions predicate can refer to.  This is limited
      by using clause_t to be 32bit.  */
   static const int num_conditions = 32;
 
